/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * Author : Alexandre Parenteau <aubonbeurre@hotmail.com> --- December 1997
 */

#if !defined(AFX_LINECMD_H__5946A8C5_8517_11D1_8949_444553540000__INCLUDED_)
#define AFX_LINECMD_H__5946A8C5_8517_11D1_8949_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// LineCmd.h : header file
//

#include "SmartComboBox.h"

#define DEF_CVS_CMD	"cvs "

class CvsArgs;

bool CompatGetCommand(CvsArgs &args, const char * &dir);
	// return the directory, false if the user canceled

#ifdef WIN32

class CCmdLine_MAIN : public CPropertyPage
{
	DECLARE_DYNCREATE(CCmdLine_MAIN)

// Construction
public:
	CCmdLine_MAIN();
	CCmdLine_MAIN(const char *lastcmd, bool hasPath, const char *lastpath);
	~CCmdLine_MAIN();

// Dialog Data
	//{{AFX_DATA(CCmdLine_MAIN)
	enum { IDD = IDD_CMDLINE_MAIN };
	CEdit	m_cmdLineEdit;
	CSmartComboBox	m_prevCmdCombo;
	CButton	m_selFolder;
	BOOL	m_checkPath;
	CString	m_cmdLine;
	CString	m_folderLoc;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCmdLine_MAIN)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCmdLine_MAIN)
	afx_msg void OnCheckpath();
	afx_msg void OnSelfolder();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangePrevcmd();
	afx_msg void OnSetfocusCmdline();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool m_firstTimeCmdline;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.
#endif /* WIN32 */

#endif // !defined(AFX_LINECMD_H__5946A8C5_8517_11D1_8949_444553540000__INCLUDED_)
